package test.test.spotifysdk06

import android.util.Log
import com.spotify.android.appremote.api.ConnectionParams
import com.spotify.android.appremote.api.Connector
import com.spotify.android.appremote.api.SpotifyAppRemote
import com.spotify.sdk.android.authentication.AuthenticationClient
import com.spotify.sdk.android.authentication.AuthenticationRequest
import com.spotify.sdk.android.authentication.AuthenticationResponse
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry
import io.flutter.plugin.common.PluginRegistry.Registrar

class Spotifysdk06Plugin(private var registrar: PluginRegistry.Registrar): MethodCallHandler {

  private val clientId = "65fd9b2b0ee74575a6d26223a1675917"
  private val redirectUri = "spotify-flutter://callback"
  private var spotifyAppRemote: SpotifyAppRemote? = null
  private val requestCode = 1337
  private var mRegistrar: PluginRegistry.Registrar? = null
  private val REQUEST_CODE = 1337

  companion object {
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "spotifysdk06")
      channel.setMethodCallHandler(Spotifysdk06Plugin(registrar))
    }
  }

  override fun onMethodCall(call: MethodCall, result: Result) {
    if (call.method == "getPlatformVersion") {
      val connectionParams = ConnectionParams.Builder(clientId)
              .setRedirectUri(redirectUri)
              .showAuthView(true)
              .build()

      SpotifyAppRemote.connect(registrar.context(), connectionParams, object : Connector.ConnectionListener {
        override fun onConnected(appRemote: SpotifyAppRemote) {
          spotifyAppRemote = appRemote
          Log.d("Spotify App Remote Logi", "Connected!")
        }

        override fun onFailure(throwable: Throwable) {
          Log.e("Spotify App Remote Logi", "Error!", throwable)
        }
      })

      //Auth SDK

      try {
        AuthenticationClient.openLoginActivity(
                registrar.activity(), REQUEST_CODE,
                AuthenticationRequest.Builder(clientId, AuthenticationResponse.Type.TOKEN,redirectUri)
                        .setScopes(arrayOf("user-modify-playback-state")).build())
      }catch (err:Throwable){
        Log.v("getAuthTokenError",err.message.toString())
      }
      registrar.addActivityResultListener { requestCode, resultCode, intent ->
        if (requestCode == REQUEST_CODE){
          val response = AuthenticationClient.getResponse(resultCode, intent)
          Log.d("Jonas", "test1")
          result.success(response.accessToken)
        }
        true
      }
    } else {
      Log.d("Jonas", "test2")
      result.notImplemented()
    }
  }
}
